namespace FS.API.UCenter.UCAPI
{
    using System;
    using System.Collections.Specialized;
    /// <summary>
    /// Դ
    /// ޸ߣDozer
    /// ϵʽmail@dozerstudio.com
    /// </summary>
    public static class UCRequestActions
    {
        public const string UC_ACTION_ADDFEED = "addfeed";
        private static StringCollection uc_action_array;
        public const string UC_ACTION_DELETEUSER = "deleteuser";
        public const string UC_ACTION_GETCREDITSETTINGS = "getcreditsettings";
        public const string UC_ACTION_GETTAG = "gettag";
        public const string UC_ACTION_RENAMEUSER = "renameuser";
        public const string UC_ACTION_SYNLOGIN = "synlogin";
        public const string UC_ACTION_SYNLOGOUT = "synlogout";
        public const string UC_ACTION_TEST = "test";
        public const string UC_ACTION_UPDATEAPPS = "updateapps";
        public const string UC_ACTION_UPDATEBADWORDS = "updatebadwords";
        public const string UC_ACTION_UPDATECLIENT = "updateclient";
        public const string UC_ACTION_UPDATECREDIT = "updatecredit";
        public const string UC_ACTION_UPDATECREDITSETTINGS = "updatecreditsettings";
        public const string UC_ACTION_UPDATEHOSTS = "updatehosts";
        public const string UC_ACTION_UPDATEPW = "updatepw";

        static UCRequestActions()
        {
            if (uc_action_array == null)
            {
                uc_action_array = new StringCollection();
                uc_action_array.Add("test");
                uc_action_array.Add("deleteuser");
                uc_action_array.Add("renameuser");
                uc_action_array.Add("gettag");
                uc_action_array.Add("synlogin");
                uc_action_array.Add("synlogout");
                uc_action_array.Add("updatepw");
                uc_action_array.Add("updatebadwords");
                uc_action_array.Add("updatehosts");
                uc_action_array.Add("updateapps");
                uc_action_array.Add("updateclient");
                uc_action_array.Add("updatecredit");
                uc_action_array.Add("getcreditsettings");
                uc_action_array.Add("updatecreditsettings");
                uc_action_array.Add("addfeed");
            }
        }

        public static bool IsValidAction(string action)
        {
            return uc_action_array.Contains(action.ToLower());
        }
    }
}

